Index: trunk/sources/HeuristicLab 3.2.sln
===================================================================
--- trunk/sources/HeuristicLab 3.2.sln	(revision 2847)
+++ trunk/sources/HeuristicLab 3.2.sln	(revision 2848)
@@ -346,4 +346,10 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.ALGLIB-2.3.0", "HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\2.3.0\HeuristicLab.ALGLIB-2.3.0\HeuristicLab.ALGLIB-2.3.0.csproj", "{8113BA87-375C-47C7-B005-8F36062B194E}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Hive.Server.LINQDataAccess-3.2", "HeuristicLab.Hive.Server.LINQDataAccess\3.2\HeuristicLab.Hive.Server.LINQDataAccess-3.2.csproj", "{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}"
+EndProject
+Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "HeuristicLab.SpringNET", "HeuristicLab.SpringNET", "{7226CBF2-CCBE-42AD-84F1-2ADF698D5934}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.SpringNET-1.3.0", "HeuristicLab.ExtLibs\HeuristicLab.SpringNET\1.3.0\HeuristicLab.SpringNET-1.3.0.csproj", "{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1}"
 EndProject
 Global
@@ -2820,4 +2826,47 @@
 		{8113BA87-375C-47C7-B005-8F36062B194E}.Release|x86.ActiveCfg = Release|x86
 		{8113BA87-375C-47C7-B005-8F36062B194E}.Release|x86.Build.0 = Release|x86
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.CEDMA Debug|x64.ActiveCfg = Debug|x64
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.CEDMA Debug|x64.Build.0 = Debug|x64
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.CEDMA Debug|x86.ActiveCfg = Debug|x86
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.CEDMA Debug|x86.Build.0 = Debug|x86
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.Debug|x64.ActiveCfg = Debug|x64
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.Debug|x64.Build.0 = Debug|x64
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.Debug|x86.ActiveCfg = Debug|x86
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.Debug|x86.Build.0 = Debug|x86
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.Modeling Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.Modeling Debug|Any CPU.Build.0 = Debug|Any CPU
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.Modeling Debug|x64.ActiveCfg = Debug|x64
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.Modeling Debug|x64.Build.0 = Debug|x64
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.Modeling Debug|x86.ActiveCfg = Debug|x86
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.Modeling Debug|x86.Build.0 = Debug|x86
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.Release|Any CPU.Build.0 = Release|Any CPU
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.Release|x64.ActiveCfg = Release|x64
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.Release|x64.Build.0 = Release|x64
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.Release|x86.ActiveCfg = Release|x86
+		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.Release|x86.Build.0 = Release|x86
+		{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
+		{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1}.CEDMA Debug|x64.ActiveCfg = Debug|Any CPU
+		{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1}.CEDMA Debug|x86.ActiveCfg = Debug|Any CPU
+		{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1}.Debug|x64.ActiveCfg = Debug|x64
+		{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1}.Debug|x64.Build.0 = Debug|x64
+		{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1}.Debug|x86.ActiveCfg = Debug|x86
+		{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1}.Debug|x86.Build.0 = Debug|x86
+		{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1}.Modeling Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1}.Modeling Debug|Any CPU.Build.0 = Debug|Any CPU
+		{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1}.Modeling Debug|x64.ActiveCfg = Debug|Any CPU
+		{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1}.Modeling Debug|x86.ActiveCfg = Debug|Any CPU
+		{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1}.Release|Any CPU.Build.0 = Release|Any CPU
+		{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1}.Release|x64.ActiveCfg = Release|x64
+		{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1}.Release|x64.Build.0 = Release|x64
+		{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1}.Release|x86.ActiveCfg = Release|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
@@ -2832,4 +2881,5 @@
 		{C2614CCD-A8B9-4BA2-86DA-6584CAA0087C} = {A0AEB817-CAC7-4DC8-8D39-0E040BA027E5}
 		{92CB7C8C-0175-44E9-B7A6-73BFC5392D79} = {A0AEB817-CAC7-4DC8-8D39-0E040BA027E5}
+		{7226CBF2-CCBE-42AD-84F1-2ADF698D5934} = {A0AEB817-CAC7-4DC8-8D39-0E040BA027E5}
 		{DD1A12A4-88DE-4991-8CBC-9AC2E57EADC3} = {D04A93C2-6903-4DCA-8803-2EBF60975E47}
 		{678E2145-8152-4E19-9646-07D439D00301} = {DD1A12A4-88DE-4991-8CBC-9AC2E57EADC3}
@@ -2849,4 +2899,5 @@
 		{B5EAF001-021A-4572-84E3-FED4B8AEBBAB} = {7DDC2DD6-9871-4559-B164-144AB7E10C01}
 		{8113BA87-375C-47C7-B005-8F36062B194E} = {7DDC2DD6-9871-4559-B164-144AB7E10C01}
+		{48D4AEB1-2247-4B58-8B63-20B81BF8D4B1} = {7226CBF2-CCBE-42AD-84F1-2ADF698D5934}
 	EndGlobalSection
 EndGlobal
Index: trunk/sources/HeuristicLab/Files.txt
===================================================================
--- trunk/sources/HeuristicLab/Files.txt	(revision 2847)
+++ trunk/sources/HeuristicLab/Files.txt	(revision 2848)
@@ -62,4 +62,5 @@
 
 HeuristicLab.Hive.Server.ADODataAccess\3.2:HeuristicLab.Hive.Server.ADODataAccess-3.2.dll 
+HeuristicLab.Hive.Server.LINQDataAccess\3.2:HeuristicLab.Hive.Server.LINQDataAccess-3.2.dll 
 HeuristicLab.Hive.Server.Console\3.2:HeuristicLab.Hive.Server.Console-3.2.dll 
 HeuristicLab.Hive.Server.Core\3.2:HeuristicLab.Hive.Server.Core-3.2.dll 
@@ -150,4 +151,10 @@
 HeuristicLab.ExtLibs\HeuristicLab.SharpDevelop\3.1.1.5327:Mono License.txt
 
+HeuristicLab.ExtLibs\HeuristicLab.SpringNET\1.3.0:HeuristicLab.SpringNET-1.3.0.dll
+HeuristicLab.ExtLibs\HeuristicLab.SpringNET\1.3.0:Common.Logging.dll
+HeuristicLab.ExtLibs\HeuristicLab.SpringNET\1.3.0:Spring.Aop.dll
+HeuristicLab.ExtLibs\HeuristicLab.SpringNET\1.3.0:Spring.Core.dll
+HeuristicLab.ExtLibs\HeuristicLab.SpringNET\1.3.0:Spring.Services.dll
+
 HeuristicLab.ExtLibs\HeuristicLab.SQLite\1.0.65.0:HeuristicLab.SQLite-1.0.65.0.dll 
 HeuristicLab.ExtLibs\HeuristicLab.SQLite\1.0.65.0:SQLite License.txt 